diff --git a/CMakeLists.txt b/CMakeLists.txt
index 3b1f675bd..0ede87541 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -5,6 +5,8 @@ project(libredwg C)
 #                   -DLIBREDWG_DISABLE_JSON=On
 #                   -DENABLE_MIMALLOC=On
 #                   -DENABLE_LTO=Off
+#                   -DDXF_PRECISION=6
+#                   -DGEOMJSON_PRECISION=6
 # for smaller builds and lib.
 
 if(MSVC)
@@ -41,6 +43,8 @@ endif()
 if (LIBREDWG_DISABLE_WRITE)
   set(BUILD_SHARED_LIBS OFF)
 endif()
+option(DXF_PRECISION "number of DXF after-comma places" 16)
+option(GEOJSON_PRECISION "number of GeoJSON after-comma places (6 recoomended by RFC)" 16)
 
 include(CheckIncludeFile)
 CHECK_INCLUDE_FILE("stddef.h" HAVE_STDDEF_H)
diff --git a/README b/README
index d2a3b5b6f..c525156bc 100644
--- a/README
+++ b/README
@@ -113,6 +113,16 @@ customize the installation dirs.  Other options recognized by configure are:
     Its value is an integer: 0 (no output) through 9 (full verbosity).
     Most tools do support a --verbosity|-v flag instead.
 
+  --with-dxf-precision=rfc
+
+   How many after-comma places in DXF doubles. 6 is the recommended
+   value (e.g. use rfc), max and the default is 16.
+
+  --with-geojson-precision=rfc
+
+   How many after-comma places in GeoJSON doubles. 6 is the
+   recommended value by RFC 7946, max and the default is 16.
+
   --disable-write
 
     Disable DWG write support (default: no).
diff --git a/configure.ac b/configure.ac
index 2e95c5b0b..cef8d5ac3 100644
--- a/configure.ac
+++ b/configure.ac
@@ -386,6 +386,34 @@ AC_ARG_ENABLE([trace],AS_HELP_STRING([--enable-trace],[
   AC_MSG_RESULT([yes]),
   AC_MSG_RESULT([no (default)]))
 
+dnl check for --with-dxf-precision=rfc or max or num
+AC_MSG_CHECKING([for --with-dxf-precision])
+AC_ARG_WITH([dxf-precision],
+    AS_HELP_STRING([--with-dxf-precision=],
+        [How many digits in the dxf. The recommended low-precision 6 or some number or @<:@default=max@:>@]),
+	[case "${with_dxf_precision}" in
+	 max|16) with_dxf_precision=16; AC_MSG_RESULT([max]) ;;
+	 rfc|6)  with_dxf_precision=6;  AC_MSG_RESULT([rfc]) ;;
+	 [6-9]|1[0-6]) AC_MSG_RESULT([${with_dxf_precision}]) ;;
+	 *)      AC_MSG_RESULT([invalid ${with_dxf_precision}: rfc,max or some number]) ;;
+	 esac],
+        [with_dxf_precision=16; AC_MSG_RESULT([max (default)]) ])
+AC_DEFINE_UNQUOTED([DXF_PRECISION],[${with_dxf_precision}],[Number of dxf after-comma places (default 16).])
+
+dnl check for --with-geojson-precision=rfc or max or num
+AC_MSG_CHECKING([for --with-geojson-precision])
+AC_ARG_WITH([geojson-precision],
+    AS_HELP_STRING([--with-geojson-precision=],
+        [How many digits in the geojson. The RFC7946 recommended 6 or some number or @<:@default=max@:>@]),
+	[case "${with_geojson_precision}" in
+	 max|16) with_geojson_precision=16; AC_MSG_RESULT([max]) ;;
+	 rfc|6)  with_geojson_precision=6;  AC_MSG_RESULT([rfc]) ;;
+	 [6-9]|1[0-6]) AC_MSG_RESULT([${with_geojson_precision}]) ;;
+	 *)      AC_MSG_RESULT([invalid ${with_geojson_precision}: rfc,max or some number]) ;;
+	 esac],
+        [with_geojson_precision=16; AC_MSG_RESULT([max (default)]) ])
+AC_DEFINE_UNQUOTED([GEOJSON_PRECISION],[${with_geojson_precision}],[Number of geojson after-comma places (recommended 6 by RFC).])
+
 AC_MSG_CHECKING([for --disable-werror])
 AC_ARG_ENABLE([werror],AS_HELP_STRING([--disable-werror],[
     Disable -Werror (default: no).]),[],[enable_werror=yes])
diff --git a/src/classes.inc b/src/classes.inc
index 311f80802..0373353bb 100644
--- a/src/classes.inc
+++ b/src/classes.inc
@@ -25,9 +25,6 @@
 # error ACTION define missing: decode, encode, dxf, indxf, print, free, ...
 #endif
 
-#define _XSTR(s) _STR(s)
-#define _STR(s)  #s
-
 #define WARN_UNHANDLED_CLASS                                                  \
   LOG_WARN ("Unhandled Class %s %d %s (0x%x%s) %u/" FORMAT_RLLx,              \
             is_entity ? "entity" : "object", klass->number, klass->dxfname,   \
diff --git a/src/cmakeconfig.h.in b/src/cmakeconfig.h.in
index 4e2a6deb9..df68fbd54 100644
--- a/src/cmakeconfig.h.in
+++ b/src/cmakeconfig.h.in
@@ -27,6 +27,12 @@
 #  undef DISABLE_JSON
 #endif   
 
+/* Number of dxf after-comma places. */
+#cmakedefine DXF_PRECISION
+
+/* Number of GeoJSON after-comma places (recommended 6 by RFC). */
+#cmakedefine GEOJSON_PRECISION
+
 /* Define if a shared library will be built */
 #cmakedefine ENABLE_SHARED
 
diff --git a/src/common.h b/src/common.h
index fdc733ef1..8a8bc9050 100644
--- a/src/common.h
+++ b/src/common.h
@@ -226,11 +226,9 @@ EXPORT int strcasecmp (const char *a, const char *b);
 #  define CC_DIAG_PRAGMA(x)
 #endif
 
-/*
-#define _STR(x)  #x
-#define STR(x)_STR(x)
-#pragma message("_GNUC_VERSION " STR(_GNUC_VERSION))
-*/
+#define _STR(s) #s
+#define _XSTR(s) _STR(s)
+// #pragma message("_GNUC_VERSION " _XSTR(_GNUC_VERSION))
 
 // clang-specifics (rarely needed, as they mimic GCC diagnostics closely, even
 // down to bugs)
diff --git a/src/config.h.in b/src/config.h.in
index 5abe9f439..3b7fa4901 100644
--- a/src/config.h.in
+++ b/src/config.h.in
@@ -21,12 +21,18 @@
 /* Define to disable JSON and GeoJSON in/out modules. */
 #undef DISABLE_JSON
 
+/* Number of dxf after-comma places (default 16). */
+#undef DXF_PRECISION
+
 /* Define to 1 if mimalloc-override.h should be used. */
 #undef ENABLE_MIMALLOC
 
 /* Define to 1 if a shared library will be built */
 #undef ENABLE_SHARED
 
+/* Number of geojson after-comma places (recommended 6 by RFC). */
+#undef GEOJSON_PRECISION
+
 /* versions earlier than 301 will have no size_t */
 #undef GPERF_VERSION
 
diff --git a/src/out_dxf.h b/src/out_dxf.h
index c588c29d5..bbee44629 100644
--- a/src/out_dxf.h
+++ b/src/out_dxf.h
@@ -24,8 +24,11 @@
 #ifdef IN_DXF_H
 #  error in_dxf.h must be included after out_dxf.h because of FORMAT_BD
 #endif
+#ifndef DXF_PRECISION
+#  define DXF_PRECISION 16
+#endif
 
-#define DXF_FORMAT_FLT "%0.16G"
+#define DXF_FORMAT_FLT "%0." _XSTR(DXF_PRECISION) "G"
 #define DXF_FLT_MAXLEN 18
 
 const char *dxf_format (int code) RETURNS_NONNULL;
diff --git a/src/out_geojson.c b/src/out_geojson.c
index 76e5b17c7..1ea391ef3 100644
--- a/src/out_geojson.c
+++ b/src/out_geojson.c
@@ -48,9 +48,14 @@
 /* the current version per spec block */
 static unsigned int cur_ver = 0;
 
-/* https://tools.ietf.org/html/rfc7946#section-11.2 */
+/* https://tools.ietf.org/html/rfc7946#section-11.2 recommends.
+   Set via --with-geojson-precision=rfc */
 #undef FORMAT_RD
-#define FORMAT_RD "%f"
+#ifndef GEOJSON_PRECISION
+#  define GEOJSON_PRECISION 6
+#endif
+#define FORMAT_RD "%0." _XSTR(GEOJSON_PRECISION) "f"
+//#define FORMAT_RD "%f"
 #undef FORMAT_BD
 #define FORMAT_BD FORMAT_RD
 
